## Generic values

Generic values — A polymorphic type that can hold values of any other type

## Functions

#define | G_VALUE_HOLDS ()
#define | G_VALUE_TYPE ()
#define | G_VALUE_TYPE_NAME ()
#define | G_TYPE_IS_VALUE ()
#define | G_TYPE_IS_VALUE_ABSTRACT ()
#define | G_IS_VALUE ()
GValue * | g_value_init ()
void | g_value_copy ()
GValue * | g_value_reset ()
void | g_value_unset ()
void | g_value_init_from_instance ()
void | g_value_set_instance ()
gboolean | g_value_fits_pointer ()
gpointer | g_value_peek_pointer ()
gboolean | g_value_type_compatible ()
gboolean | g_value_type_transformable ()
gboolean | g_value_transform ()
void | ( *GValueTransform ) ()
void | g_value_register_transform_func ()
gchar * | g_strdup_value_contents ()

## Types and Values

#define | G_VALUE_INIT
| GValue
#define | G_TYPE_VALUE
#define | G_TYPE_VALUE_ARRAY

## Includes

    #include <glib-object.h>

## Description

The GValue structure is basically a variable container that consists of a type identifier and a specific value of that type. The type identifier within a GValue structure always determines the type of the associated value. To create a undefined GValue structure, simply create a zero-filled GValue structure. To initialize the GValue, use the `g_value_init()` function. A GValue cannot be used until it is initialized. The basic type operations (such as freeing and copying) are determined by the GTypeValueTable associated with the type ID stored in the GValue. Other GValue operations (such as converting values between types) are provided by this interface.

The code in the example program below demonstrates GValue's features.

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52

    #include <glib-object.h>

    static void
    int2string (const GValue *src_value,
                GValue       *dest_value)
    {
      if (g_value_get_int (src_value) == 42)
        g_value_set_static_string (dest_value, "An important number");
      else
        g_value_set_static_string (dest_value, "What's that?");
    }

    int
    main (int   argc,
          char *argv[])
    {
      // GValues must be initialized
      GValue a = G_VALUE_INIT;
      GValue b = G_VALUE_INIT;
      const gchar *message;

      // The GValue starts empty
      g_assert (!G_VALUE_HOLDS_STRING (&a));

      // Put a string in it
      g_value_init (&a, G_TYPE_STRING);
      g_assert (G_VALUE_HOLDS_STRING (&a));
      g_value_set_static_string (&a, "Hello, world!");
      g_printf ("%s\n", g_value_get_string (&a));

      // Reset it to its pristine state
      g_value_unset (&a);

      // It can then be reused for another type
      g_value_init (&a, G_TYPE_INT);
      g_value_set_int (&a, 42);

      // Attempt to transform it into a GValue of type STRING
      g_value_init (&b, G_TYPE_STRING);

      // An INT is transformable to a STRING
      g_assert (g_value_type_transformable (G_TYPE_INT, G_TYPE_STRING));

      g_value_transform (&a, &b);
      g_printf ("%s\n", g_value_get_string (&b));

      // Attempt to transform it again using a custom transform function
      g_value_register_transform_func (G_TYPE_INT, G_TYPE_STRING, int2string);
      g_value_transform (&a, &b);
      g_printf ("%s\n", g_value_get_string (&b));
      return 0;
    }

## Functions

### G_VALUE_HOLDS()

    #define G_VALUE_HOLDS(value,type) (G_TYPE_CHECK_VALUE_TYPE ((value), (type)))

Checks if `value` holds (or contains) a value of `type` . This macro will also check for `value` != `NULL` and issue a warning if the check fails.

#### Parameters

value | A GValue structure. |
type | A GType value. |

#### Returns

`TRUE` if `value` holds the `type` .

### G_VALUE_TYPE()

    #define G_VALUE_TYPE(value)		(((GValue*) (value))->g_type)

Get the type identifier of `value` .

#### Parameters

value | A GValue structure. |

#### Returns

the GType.

### G_VALUE_TYPE_NAME()

    #define G_VALUE_TYPE_NAME(value) (g_type_name (G_VALUE_TYPE (value)))

Gets the type name of `value` .

#### Parameters

value | A GValue structure. |

#### Returns

the type name.

### G_TYPE_IS_VALUE()

    #define G_TYPE_IS_VALUE(type)		(g_type_check_is_value_type (type))

Checks whether the passed in type ID can be used for `g_value_init()`. That is, this macro checks whether this type provides an implementation of the GTypeValueTable functions required for a type to create a GValue of.

#### Parameters

type | A GType value. |

#### Returns

Whether `type` is suitable as a GValue type.

### G_TYPE_IS_VALUE_ABSTRACT()

    #define G_TYPE_IS_VALUE_ABSTRACT(type)          (g_type_test_flags ((type), G_TYPE_FLAG_VALUE_ABSTRACT))

Checks if `type` is an abstract value type. An abstract value type introduces a value table, but can't be used for `g_value_init()` and is normally used as an abstract base type for derived value types.

#### Parameters

type | A GType value |

#### Returns

`TRUE` on success

### G_IS_VALUE()

    #define G_IS_VALUE(value)		(G_TYPE_CHECK_VALUE (value))

Checks if `value` is a valid and initialized GValue structure.

#### Parameters

value | A GValue structure. |

#### Returns

`TRUE` on success.

### g_value_init ()

    GValue *
    g_value_init (GValue *value,
                  GType g_type);

Initializes `value` with the default value of `type` .

#### Parameters

value | A zero-filled (uninitialized) GValue structure. |
g_type | Type the GValue should hold values of. |

#### Returns

the GValue structure that has been passed in.

[transfer none]

### g_value_copy ()

    void
    g_value_copy (const GValue *src_value,
                  GValue *dest_value);

Copies the value of `src_value` into `dest_value` .

#### Parameters

src_value | An initialized GValue structure. |
dest_value | An initialized GValue structure of the same type as `src_value` . |

### g_value_reset ()

    GValue *
    g_value_reset (GValue *value);

Clears the current value in `value` and resets it to the default value (as if the value had just been initialized).

#### Parameters

value | An initialized GValue structure. |

#### Returns

the GValue structure that has been passed in

### g_value_unset ()

    void
    g_value_unset (GValue *value);

Clears the current value in `value` (if any) and "unsets" the type, this releases all resources associated with this GValue. An unset value is the same as an uninitialized (zero-filled) GValue structure.

#### Parameters

value | An initialized GValue structure. |

### g_value_init_from_instance ()

    void
    g_value_init_from_instance (GValue *value,
                                gpointer instance);

Initializes and sets `value` from an instantiatable type via the value_table's `collect_value()` function.

Note: The `value` will be initialised with the exact type of `instance` . If you wish to set the `value` 's type to a different GType (such as a parent class GType), you need to manually call `g_value_init()` and `g_value_set_instance()`.

#### Parameters

value | An uninitialized GValue structure. |
instance | the instance. | [type GObject.TypeInstance]

Since: 2.42

### g_value_set_instance ()

    void
    g_value_set_instance (GValue *value,
                          gpointer instance);

Sets `value` from an instantiatable type via the value_table's `collect_value()` function.

#### Parameters

value | An initialized GValue structure. |
instance | the instance. | [nullable]

### g_value_fits_pointer ()

    gboolean
    g_value_fits_pointer (const GValue *value);

Determines if `value` will fit inside the size of a pointer value. This is an internal function introduced mainly for C marshallers.

#### Parameters

value | An initialized GValue structure. |

#### Returns

`TRUE` if `value` will fit inside a pointer value.

### g_value_peek_pointer ()

    gpointer
    g_value_peek_pointer (const GValue *value);

Returns the value contents as pointer. This function asserts that `g_value_fits_pointer()` returned `TRUE` for the passed in value. This is an internal function introduced mainly for C marshallers.

#### Parameters

value | An initialized GValue structure |

#### Returns

the value contents as pointer.

[transfer none]

### g_value_type_compatible ()

    gboolean
    g_value_type_compatible (GType src_type,
                             GType dest_type);

Returns whether a GValue of type `src_type` can be copied into a GValue of type `dest_type` .

#### Parameters

src_type | source type to be copied. |
dest_type | destination type for copying. |

#### Returns

`TRUE` if `g_value_copy()` is possible with `src_type` and `dest_type` .

### g_value_type_transformable ()

    gboolean
    g_value_type_transformable (GType src_type,
                                GType dest_type);

Check whether `g_value_transform()` is able to transform values of type `src_type` into values of type `dest_type` . Note that for the types to be transformable, they must be compatible or a transformation function must be registered.

#### Parameters

src_type | Source type. |
dest_type | Target type. |

#### Returns

`TRUE` if the transformation is possible, `FALSE` otherwise.

### g_value_transform ()

    gboolean
    g_value_transform (const GValue *src_value,
                       GValue *dest_value);

Tries to cast the contents of `src_value` into a type appropriate to store in `dest_value` , e.g. to transform a `G_TYPE_INT` value into a `G_TYPE_FLOAT` value. Performing transformations between value types might incur precision lossage. Especially transformations into strings might reveal seemingly arbitrary results and shouldn't be relied upon for production code (such as rcfile value or object property serialization).

#### Parameters

src_value | Source value. |
dest_value | Target value. |

#### Returns

Whether a transformation rule was found and could be applied. Upon failing transformations, `dest_value` is left untouched.

### GValueTransform ()

    void
    (*GValueTransform) (const GValue *src_value,
                        GValue *dest_value);

The type of value transformation functions which can be registered with `g_value_register_transform_func()`.

#### Parameters

src_value | Source value. |
dest_value | Target value. |

### g_value_register_transform_func ()

    void
    g_value_register_transform_func (GType src_type,
                                     GType dest_type,
                                     GValueTransform transform_func);

Registers a value transformation function for use in `g_value_transform()`. A previously registered transformation function for `src_type` and `dest_type` will be replaced.

[skip]

#### Parameters

src_type | Source type. |
dest_type | Target type. |
transform_func | a function which transforms values of type `src_type` into value of type `dest_type` |

### g_strdup_value_contents ()

    gchar *
    g_strdup_value_contents (const GValue *value);

Return a newly allocated string, which describes the contents of a GValue. The main purpose of this function is to describe GValue contents for debugging output, the way in which the contents are described may change between different GLib versions.

#### Parameters

value | GValue which contents are to be described. |

#### Returns

Newly allocated string.

## Types and Values

### G_VALUE_INIT

    #define G_VALUE_INIT  { 0, { { 0 } } }

A GValue must be initialized before it can be used. This macro can be used as initializer instead of an explicit `{ 0 }` when declaring a variable, but it cannot be assigned to a variable.

    1

    GValue value = G_VALUE_INIT;

Since: 2.30

### GValue

    typedef struct {
    } GValue;

An opaque structure used to hold different types of values. The data within the structure has protected scope: it is accessible only to functions within a GTypeValueTable structure, or implementations of the g_value_*() API. That is, code portions which implement new fundamental types. GValue users cannot make any assumptions about how data is stored within the 2 element `data` union, and the `g_type` member should only be accessed through the `G_VALUE_TYPE()` macro.

### G_TYPE_VALUE

    #define G_TYPE_VALUE (g_value_get_type ())

The type ID of the "GValue" type which is a boxed type, used to pass around pointers to GValues.

### G_TYPE_VALUE_ARRAY

    #define G_TYPE_VALUE_ARRAY (g_value_array_get_type ())

`G_TYPE_VALUE_ARRAY` has been deprecated since version 2.32 and should not be used in newly-written code.

Use GArray instead of GValueArray

The type ID of the "GValueArray" type which is a boxed type, used to pass around pointers to GValueArrays.

## See Also

The fundamental types which all support GValue operations and thus can be used as a type initializer for `g_value_init()` are defined by a separate interface. See the standard values API for details